Bug 29936 - Add ability to disable hold capture via SIP checkin
Summary: Add ability to disable hold capture via SIP checkin
Status: RESOLVED FIXED
Alias: None
Product: Koha
Classification: Unclassified
Component: SIP2 (show other bugs)
Version: master
Hardware: All All
: P5 - low enhancement (vote)
Assignee: Martin Renvoize
QA Contact: Tomás Cohen Arazi
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2022-01-25 11:02 UTC by Martin Renvoize
Modified: 2022-05-17 12:39 UTC (History)
4 users (show)

See Also:
Change sponsored?: ---
Patch complexity: Small patch
Documentation contact:
Documentation submission:
Text to go in the release notes:
This enhancement adds a new `holds_get_captured` configuration option to SIP accounts. The new option defaults to enabled, as has been the case since bug 3638 was pushed. However, it allows for disabling hold capture so that items are not automatically assigned to holds at SIP check-in; The alerts messages will continue to show, however, to allow items to be put to one side and then captured by a subsequent staff check-in.
Version(s) released in:
22.05.00


Attachments
Bug 29936: Add unit tests (2.51 KB, patch)
2022-03-10 13:55 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 29936: Add holds_get_captured option to sip config (4.02 KB, patch)
2022-03-10 13:55 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 29936: Add unit tests (2.64 KB, patch)
2022-03-10 16:50 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 29936: Add holds_get_captured option to sip config (4.14 KB, patch)
2022-03-10 16:50 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 29936: Add unit tests (2.69 KB, patch)
2022-03-10 16:52 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 29936: Add holds_get_captured option to sip config (4.19 KB, patch)
2022-03-10 16:52 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 29936: Add unit tests (2.76 KB, patch)
2022-04-25 12:20 UTC, Tomás Cohen Arazi
Details | Diff | Splinter Review
Bug 29936: Add holds_get_captured option to sip config (4.20 KB, patch)
2022-04-25 12:20 UTC, Tomás Cohen Arazi
Details | Diff | Splinter Review
Bug 29936: (follow-up) Remove useless warining (910 bytes, patch)
2022-04-25 12:21 UTC, Tomás Cohen Arazi
Details | Diff | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Martin Renvoize 2022-01-25 11:02:43 UTC
Some libraries would like patrons to be able to return items via SIP, but for those returns to not automatically trigger the hold capture and automatic transfer process. (Akin to disabling 'AutomaticItemReturn' in the preferences which allows librarians to pick the action at the point of check-in), but for SIP devices.

This enhancement would in effect makes the functionality that bug 3638 introduced optional.
Comment 1 Katrin Fischer 2022-01-25 22:13:58 UTC
Hm, isn't that what HoldsNeedProcessingSIP does?
Comment 2 Martin Renvoize 2022-01-26 08:11:34 UTC
Interesting.. very nearly. I had entirely forgotten about that new preference.. however, it doesn't appear to resolve the transfers issue.. i.e. the hold is still captured, though it's marked as processing.. in the SIP code itself, the item may then be set to in transfer..
Comment 3 Martin Renvoize 2022-01-26 08:13:32 UTC
I really wish Holds and Transfers were better tied together.. it's somewhat mad that a hold can be set to in transfer without it actually triggering a transfer (in code) and thus you have to follow any call to ModReserveAffect with a Transfer anyway.
Comment 4 Martin Renvoize 2022-01-26 08:17:52 UTC
In fact.. our customer doesn't want SIP returns to result in holds captured at all in my understanding.  They often have patrons just ignore the self check prompt to put the item into the exceptions bin and thus items are reshelved and not actually captured for the hold at all.. SO what they want is for the message to appear just in case the patron pays attention and thus puts the item in the exceptions bin.. but for the actual capture to require a staff check-in as the next step.
Comment 5 Martin Renvoize 2022-03-10 13:55:17 UTC
Created attachment 131555 [details] [review]
Bug 29936: Add unit tests

This patch adds a unit test for the new functionality introduced with
holds_get_captured allowing for holds to still be highlighted to patrons
at checkin but not mark them as found/transfered in the system.
Comment 6 Martin Renvoize 2022-03-10 13:55:21 UTC
Created attachment 131556 [details] [review]
Bug 29936: Add holds_get_captured option to sip config

This patch adds a new option to the SIP config, allowing for hold
capture to be disabled on difference devices. We still notice the hold
and alert the user, but we do not trigger the update in the system to
mark the hold as found (waiting, processing or in transit).
Comment 7 Sally 2022-03-10 16:31:45 UTC
Thanks for this, Martin - we have this running on our live system and all is working well.

Happy for my sign off to be added.
Comment 8 Martin Renvoize 2022-03-10 16:50:40 UTC
Created attachment 131575 [details] [review]
Bug 29936: Add unit tests

This patch adds a unit test for the new functionality introduced with
holds_get_captured allowing for holds to still be highlighted to patrons
at checkin but not mark them as found/transfered in the system.

Signed-off-by: Martin Renvoize <martin.renvoize@ptfs-europe.com>
Signed-off-by: Sally <sally.healey@cheshiresharedservices.gov.uk>
Comment 9 Martin Renvoize 2022-03-10 16:50:44 UTC
Created attachment 131576 [details] [review]
Bug 29936: Add holds_get_captured option to sip config

This patch adds a new option to the SIP config, allowing for hold
capture to be disabled on difference devices. We still notice the hold
and alert the user, but we do not trigger the update in the system to
mark the hold as found (waiting, processing or in transit).

Signed-off-by: Martin Renvoize <martin.renvoize@ptfs-europe.com>
Signed-off-by: Sally <sally.healey@cheshiresharedservices.gov.uk>
Comment 10 Martin Renvoize 2022-03-10 16:51:13 UTC
Excellent, thanks for confirming Sally. Signoff line added :)
Comment 11 Martin Renvoize 2022-03-10 16:52:33 UTC
Created attachment 131577 [details] [review]
Bug 29936: Add unit tests

This patch adds a unit test for the new functionality introduced with
holds_get_captured allowing for holds to still be highlighted to patrons
at checkin but not mark them as found/transfered in the system.

Sponsored-by: Cheshire Libraries Shared Services
Signed-off-by: Martin Renvoize <martin.renvoize@ptfs-europe.com>
Signed-off-by: Sally <sally.healey@cheshiresharedservices.gov.uk>
Comment 12 Martin Renvoize 2022-03-10 16:52:37 UTC
Created attachment 131578 [details] [review]
Bug 29936: Add holds_get_captured option to sip config

This patch adds a new option to the SIP config, allowing for hold
capture to be disabled on difference devices. We still notice the hold
and alert the user, but we do not trigger the update in the system to
mark the hold as found (waiting, processing or in transit).

Sponsored-by: Cheshire Libraries Shared Services
Signed-off-by: Martin Renvoize <martin.renvoize@ptfs-europe.com>
Signed-off-by: Sally <sally.healey@cheshiresharedservices.gov.uk>
Comment 13 Tomás Cohen Arazi 2022-04-25 12:20:33 UTC
Created attachment 133763 [details] [review]
Bug 29936: Add unit tests

This patch adds a unit test for the new functionality introduced with
holds_get_captured allowing for holds to still be highlighted to patrons
at checkin but not mark them as found/transfered in the system.

Sponsored-by: Cheshire Libraries Shared Services
Signed-off-by: Martin Renvoize <martin.renvoize@ptfs-europe.com>
Signed-off-by: Sally <sally.healey@cheshiresharedservices.gov.uk>
Signed-off-by: Tomas Cohen Arazi <tomascohen@theke.io>
Comment 14 Tomás Cohen Arazi 2022-04-25 12:20:51 UTC
Created attachment 133764 [details] [review]
Bug 29936: Add holds_get_captured option to sip config

This patch adds a new option to the SIP config, allowing for hold
capture to be disabled on difference devices. We still notice the hold
and alert the user, but we do not trigger the update in the system to
mark the hold as found (waiting, processing or in transit).

Sponsored-by: Cheshire Libraries Shared Services
Signed-off-by: Martin Renvoize <martin.renvoize@ptfs-europe.com>
Signed-off-by: Sally <sally.healey@cheshiresharedservices.gov.uk>
Signed-off-by: Tomas Cohen Arazi <tomascohen@theke.io>
Comment 15 Tomás Cohen Arazi 2022-04-25 12:21:06 UTC
Created attachment 133765 [details] [review]
Bug 29936: (follow-up) Remove useless warining

Signed-off-by: Tomas Cohen Arazi <tomascohen@theke.io>
Comment 16 Fridolin Somers 2022-05-05 21:20:43 UTC
Pushed to master for 22.05, thanks to everybody involved 🦄